#include <krb5.h>

#include <stdio.h>
#include "pw_check.h"

int main ()
{
	krb5_context context;
	krb5_ccache ccache;
	krb5_principal principal;

	char buffer[1024];
	int ret = 0;

	if ( ret = krb5_init_context(&context) )
	{
		fprintf(stderr, "krb5_init_context failed: %d\n", ret);
		exit(1);
	}
	krb5_init_ets(context);

	if ( ret = krb5_cc_default(context, &ccache) )
	{
		fprintf(stderr, "couldn't determine cred cache: %s\n", error_message(ret));
		exit(1);
	}

	if ( ret = krb5_cc_get_principal(context, ccache, &principal) )
	{
		fprintf(stderr, "couldn't read cred cache: %s\n",
			error_message(ret));
		exit(1);
	}

	printf("try some passwords, one per line...\n");

	while (fgets (buffer, sizeof(buffer), stdin))
	{
	 	char *val;
		krb5_data pw_data;

		buffer[strlen(buffer) - 1] = '\0';

		pw_data.data = buffer;
		pw_data.length = strlen(buffer);

		val = test_passwd(context, principal, &pw_data);
		if ( val == NULL ) val = "OK";

		printf ("%s: %s\n", buffer, val);
	}

	krb5_free_context(context);
	return 0;
}
